<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Inisial</label>

            <b-form-input
              id="input-large"
              v-model="search.searchCode"
              size="lg"
              placeholder="Masukkan Inisial"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nama</label>

            <b-form-input
              id="input-large"
              v-model="search.searchName"
              size="lg"
              placeholder="Masukkan Nama"
            ></b-form-input>
          </div>
        </div>

        <div class="d-flex mt-5 justify-content-end">
          <button class="btn btn-primary btn-md" @click.prevent="searchPic">
            <i class="flaticon2-search-1"></i> Filter
          </button>
        </div>
      </div>
    </div>

    <div class="card card-custom p-5 gutter-b">
      <div class="d-flex my-3 justify-content-start">
        <button class="btn btn-success btn-md" @click="showAddModal">
          <i class="flaticon-user-add"></i> Tambah PIC
        </button>
      </div>
      <div class="card-body p-0">
        <div class="table-loader-pic">
          <div
            class="text-center"
            v-bind:class="{
              'd-none': loadingActive
            }"
          >
            <div class="text-center">
              <div class="spinner-border text-primary" role="status">
                <span class="visually-hidden"></span>
              </div>
            </div>
          </div>
        </div>

        <complete-table
          :data="$store.getters.getterPic"
          :loading="!loadingActive"
        >
          <template #header>
            <tr class="text-left">
              <th style="min-width: 250px" class="pl-7">
                <span class="text-dark-75">Inisial</span>
              </th>
              <th style="min-width: 100px">Nama</th>
              <th style="min-width: 101px">Aksi</th>
            </tr>
          </template>

          <template #defaultBody="{ item: res, i }">
            <tr
              class="border-0"
              v-bind:key="res.code"
              v-bind:class="{
                'd-none': tableLoading
              }"
            >
              <td class="pl-0 pt-8">
                <span
                  class="
                        ml-5
                        text-dark-75
                        font-weight-bolder
                        d-block
                        font-size-lg
                      "
                >
                  {{ res.code }}
                </span>
              </td>

              <td>
                <span
                  class="
                        text-dark-75
                        font-weight-bolder
                        d-block
                        font-size-lg
                      "
                >
                  {{ res.name }}
                </span>
              </td>

              <td class="pr-0">
                <a
                  class="
                        btn btn-light-success
                        font-weight-bolder font-size-sm
                      "
                  @click.prevent="showEditModal(res)"
                >
                  <i class="flaticon-edit"></i>
                </a>
              </td>
            </tr>
          </template>
        </complete-table>
      </div>
    </div>

    <b-modal ref="add-pic" hide-footer title="Form Tambah PIC">
      <div class="d-block text-center">
        <form>
          <div class="row">
            <div class="col-md-12 py-2 col-sm-12 text-left">
              <label for="input-large">Inisial *</label>

              <b-form-input
                id="input-large"
                size="lg"
                placeholder="Masukkan Inisial"
                v-model="codepic"
              ></b-form-input>
              <span
                class="error-add-initial"
                v-bind:class="{
                  'text-danger': hasError,
                  'd-none': isActive
                }"
              >
                Initial harus diisi
              </span>
            </div>

            <div class="col-md-12 py-2 col-sm-12 text-left">
              <label for="input-large">Nama *</label>

              <b-form-input
                id="input-large"
                size="lg"
                placeholder="Masukkan Nama"
                v-model="namepic"
              ></b-form-input>
              <span
                class="error-add-name"
                v-bind:class="{
                  'text-danger': hasErrorName,
                  'd-none': isActiveName
                }"
              >
                nama harus diisi
              </span>
            </div>

            <div class="col-md-12 py-2 col-sm-12 text-left">
              <label for="input-large">Posisi *</label>

              <b-form-select
                v-model="positionpic"
                :options="positionOptions"
                size="lg"
              ></b-form-select>
              <span
                class="error-add-name"
                v-bind:class="{
                  'text-danger': hasErrorPosition,
                  'd-none': isActivePosition
                }"
              >
                posisi harus diisi
              </span>
            </div>
          </div>
        </form>
      </div>

      <div class="d-flex mt-2">
        <b-button class="btn btn-success mr-2" block @click.prevent="savePic()"
          >Simpan</b-button
        >

        <b-button class="btn btn-secondary mt-0" block @click="closeAddModal"
          >Batal</b-button
        >
      </div>
    </b-modal>

    <b-modal ref="edit-pic" hide-footer title="Form Ubah PIC">
      <div class="d-block text-center">
        <div class="row">
          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large">Inisial</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Inisial"
              v-model="form.initial"
            ></b-form-input>
          </div>

          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large">Nama</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Nama"
              v-model="form.name"
            ></b-form-input>
          </div>

          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large">Posisi</label>

            <b-form-select
              v-model="form.position"
              :options="positionOptions"
              size="lg"
            ></b-form-select>
          </div>
        </div>
      </div>

      <div class="d-flex mt-2">
        <b-button
          class="btn btn-success mr-2"
          block
          @click.prevent="saveEditPic()"
        >
          <div class="text-center">
            <b-spinner
              variant="primary"
              label="Spinning"
              v-bind:class="{
                'd-none': loaderEdit
              }"
            ></b-spinner>
          </div>
          <div
            class="text-center"
            v-bind:class="{
              'd-none': loaderEditText
            }"
          >
            Simpan
          </div>
        </b-button>

        <b-button class="btn btn-secondary mt-0" block @click="closeEditModal"
          >Batal</b-button
        >
      </div>
    </b-modal>
  </div>
</template>

<script>
import { mapState } from "vuex";
import { GET_POSITION } from "@/core/services/store/position.module";
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import { GET_LIST_PIC } from "@/core/services/store/pic.module.js";
import { SAVE_PIC } from "@/core/services/store/pic.module.js";
import { DELETE_PIC } from "@/core/services/store/pic.module.js";
import { EDIT_PIC } from "@/core/services/store/pic.module.js";
import { SEARCH_PIC } from "@/core/services/store/pic.module.js";
import Vue from "vue";
import axios from "axios";
import VueAxios from "vue-axios";
import CompleteTable from "../../content/widgets/advance-table/CompleteTable";
Vue.use(VueAxios, axios);

export default {
  name: "pic",
  components: { CompleteTable },
  data() {
    return {
      nextText: "Next",
      prevText: "Prev",
      options: {
        positions: [
          { value: "HR", text: "HR" },
          { value: "ADMIN", text: "ADMIN" }
        ]
      },
      filter: {
        initial: null,
        name: null
      },
      form: {
        id: null,
        name: null,
        initial: null,
        position: null
      },
      input: {
        namepic: null,
        codepic: null,
        positionpic: null
      },
      search: {
        searchCode: null,
        searchName: null
      },
      isActive: true,
      hasError: false,
      isActiveName: true,
      isActivePosition: true,
      hasErrorName: false,
      hasErrorPosition: false,
      loadingPrev: false,
      loadingNext: false,
      loadingActive: false,
      tableLoading: false,
      loaderEdit: true,
      loaderEditText: false,
      tableMainPic: true
    };
  },
  methods: {
    getPosition() {
      if (!(this.positions.length > 0)) {
        this.$store.dispatch(GET_POSITION, this.filter);
      }
    },

    showAddModal() {
      this.$refs["add-pic"].show();
    },

    closeAddModal() {
      this.$refs["add-pic"].hide();

      this.isActive = true;
      this.hasError = false;
      this.isActiveName = true;
      this.hasErrorName = false;
      this.initial_pic_add = "";
      this.name_pic_add = "";
    },

    showEditModal(pic) {
      Object.assign(this.form, {
        id: null,
        name: pic.name,
        initial: pic.code,
        position: pic.position.code + "." + pic.position.Name
      });

      this.$refs["edit-pic"].show();
    },

    async savePic() {
      if (this.initial_pic_add && this.name_pic_add) {
        return true;
      }

      if (!this.codepic) {
        // styling error
        this.isActive = false;
        this.hasError = true;
      }

      if (!this.namepic) {
        // styling error
        this.isActiveName = false;
        this.hasErrorName = true;
      }

      if (!this.positionpic) {
        // styling error
        this.isActivePosition = false;
        this.hasErrorPosition = true;
      }

      var name = this.namepic;
      var code = this.codepic;
      var position = this.positionpic;
      var sepr = position.split(".");
      var truePost = {
        code: sepr[0],
        name: sepr[1]
      };

      var post = {
        code: code,
        name: name,
        position: truePost
      };

      await this.$store.dispatch(SAVE_PIC, post);
      this.$store.dispatch(GET_LIST_PIC, [{ start: 0, end: 10, page: 0 }]);
      this.$refs["add-pic"].hide();

      this.isActive = true;
      this.hasError = false;
      this.isActiveName = true;
      this.hasErrorName = false;
      this.initial_pic_add = "";
      this.name_pic_add = "";
    },

    async saveEditPic() {
      if (this.initial_pic_add && this.name_pic_add) {
        return true;
      }

      var name = this.form.name;
      var code = this.form.initial;
      var position = this.form.position;
      var sp = position.split(".");
      var truePosition = {
        code: sp[0],
        name: sp[1]
      };

      var upd = {
        code: code,
        name: name,
        position: truePosition
      };

      this.loaderEdit = false;
      this.loaderEditText = true;
      this.loadingActive = false;
      this.tableMainPic = true;
      await this.$store.dispatch(EDIT_PIC, upd);
      this.loaderEdit = true;
      this.loaderEditText = false;
      this.closeEditModal();
      await this.$store.dispatch(GET_LIST_PIC, [
        { start: 0, end: 10, page: 0 }
      ]);
      this.loadingActive = true;
      this.tableMainPic = false;
    },

    deletePic(event) {
      var name = event.target.getAttribute("data-name");
      var code = event.target.getAttribute("data-code");

      var params = {
        name: name,
        code: code
      };

      this.$store.dispatch(DELETE_PIC, params);
    },

    closeEditModal() {
      this.$refs["edit-pic"].hide();
    },

    async nextPage() {
      var currPage = this.$store.getters.getterPagination;
      var activePage = currPage + 1;
      var perPage = 10;
      var startPage = perPage * activePage;
      var endPage = startPage + perPage;
      var page = [{ start: startPage, end: endPage, page: activePage }];
      this.loadingNext = true;
      this.tableLoading = true;
      this.loadingActive = false;
      await this.$store.dispatch(GET_LIST_PIC, page);
      this.loadingNext = false;
      this.tableLoading = false;
      this.loadingActive = true;
    },

    async prevPage() {
      var currPage = this.$store.getters.getterPagination;
      var activePage = currPage - 1;
      var end = this.$store.getters.getterEndPage - 10;
      var start = this.$store.getters.getterStartPage - 10;
      var page = [{ start: start, end: end, page: activePage }];
      this.loadingPrev = true;
      this.tableLoading = true;
      this.loadingActive = false;
      await this.$store.dispatch(GET_LIST_PIC, page);
      this.loadingPrev = false;
      this.tableLoading = false;
      this.loadingActive = true;
    },

    searchPic() {
      var code = this.search.searchCode;
      var param = { name: code };
      this.$store.dispatch(SEARCH_PIC, param);
    }
  },

  async mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [{ title: "PIC" }]);

    await this.$store.dispatch(GET_LIST_PIC, [{ start: 0, end: 10, page: 0 }]);
    this.loadingActive = true;
    this.tableMainPic = false;

    this.getPosition();
  },
  computed: {
    ...mapState({
      errors: state => state.position.errors,
      positions: state => state.position.positions?.data ?? [],
      showPics: state => state.listPic
    }),

    positionOptions() {
      return this.positions.map(position => {
        return {
          value: position.code + "." + position.Name,
          text: position.Name
        };
      });
    }
  }
};
</script>

<style></style>
